<div class="row">
  <div class="col-12">
    <div
      *ngIf="
        currQuestion.programmingLanguages &&
        currQuestion.programmingLanguages.length > 1
      "
      class="pull-right"
    >
      <div class="form-inline">
        <label for="question-answer-programming-language">
          <small>Language:</small>
        </label>
        <select
          class="form-control-sm"
          (change)="onLanguageChanged($event.target?.value)"
        >
          <option
            *ngFor="
              let language of currQuestion.programmingLanguages;
              let i = index
            "
            [value]="language.id"
            [selected]="getCurrLangId() === language.id"
          >
            {{ language.name }}
          </option>
        </select>
      </div>
    </div>
  </div>
</div>
<div class="row">
  <div class="col-12">
    <div class="edgar-overlap border">
      <code-mirror
        #codeMirror
        [initialCode]="getCurrCode()"
        [questionType]="currQuestion.type"
        [programmingLanguages]="currQuestion.programmingLanguages"
        [langId]="getCurrLangId()"
        [cmSkin]="cmSkin"
        (runCodeHotkey)="run($event)"
        (codeChanged)="onCodeChanged($event)"
      ></code-mirror>
      <div class="edgar-right-overlap">
        <button
          class="btn btn-warning col-1 edgar-overlap-btn-w"
          type="submit"
          [disabled]="queryRunning || !canRun()"
          title="Ctrl+Enter"
          (click)="runAll()"
        >
          <span
            [innerHTML]="queryRunning | sqlRunLabel : currQuestionWait"
          ></span>
        </button>
      </div>
      <div class="edgar-right-overlap2">
        <button
          class="btn btn-success col-1 edgar-overlap-btn-w"
          type="submit"
          [disabled]="saved"
          (click)="save()"
        >
          Save
        </button>
      </div>
    </div>
  </div>
</div>
<div *ngIf="_errMessage" class="row text-center text-danger edgar-code">
  {{ _errMessage }}
</div>
<div *ngIf="getResult()" class="mt-2">
  <div
    *ngIf="getResult().success"
    [ngClass]="{
      correct: getResult().score && getResult().score.is_correct,
      incorrect: getResult().score && getResult().score.is_incorrect
    }"
  >
    <ng-container *ngIf="currQuestion.isSQL()">
      <grid [result]="getResult()"></grid>
    </ng-container>
    <ng-container *ngIf="currQuestion.isCodeLang()">
      <clang-result [isRevision]="false" [result]="getResult()"></clang-result>
    </ng-container>
    <ng-container *ngIf="currQuestion.isJSON()">
      <json-result
        [isRevision]="false"
        [queryRunning]="queryRunning"
        [result]="getResult()"
      ></json-result>
    </ng-container>
  </div>
  <div *ngIf="!getResult().success">
    <div class="text-left aii-error custom">
      {{ getResult().error.message }}
      <div *ngIf="getResult().error.position">
        Position: {{ getResult().error.position }}
      </div>
    </div>
  </div>
</div>
